diff --git a/django/db/models/query.py b/django/db/models/query.py
index fedb61ed5d..7c934a6271 100644
--- a/django/db/models/query.py
+++ b/django/db/models/query.py
@@ -2566,45 +2688,49 @@ class QuerySet(AltersData):
         return self._filter_or_exclude(True, args, kwargs)
 
     def _filter_or_exclude(self, negate, args, kwargs):
-        from django import native as _native
-
-        if _native.AVAILABLE:
-            if _native.filter_after_slice_error(
-                bool(args or kwargs), self.query.is_sliced
-            ):
-                raise TypeError("Cannot filter a query once a slice has been taken.")
-        elif (args or kwargs) and self.query.is_sliced:
+        if (
+            (args or kwargs)
+            and self._query is not None
+            and self._query.is_sliced
+        ):
             raise TypeError("Cannot filter a query once a slice has been taken.")
         clone = self._chain()
         if self._defer_next_filter:
             self._defer_next_filter = False
             clone._deferred_filter = negate, args, kwargs
         else:
-            clone._filter_or_exclude_inplace(negate, args, kwargs)
-            clone._native_track_filter(negate, args, kwargs)
-        return clone
-
-    def _filter_or_exclude_inplace(self, negate, args, kwargs):
-        from django import native as _native
-
-        if _native.AVAILABLE:
-            invalid_kwargs = _native.prohibited_filter_kwargs(list(kwargs.keys()))
+            invalid_kwargs = PROHIBITED_FILTER_KWARGS.intersection(kwargs)
             if invalid_kwargs:
-                invalid_kwargs_str = ", ".join(f"'{k}'" for k in invalid_kwargs)
+                invalid_kwargs_str = ", ".join(f"'{k}'" for k in sorted(invalid_kwargs))
                 raise TypeError(
                     f"The following kwargs are invalid: {invalid_kwargs_str}"
                 )
-        elif invalid_kwargs := PROHIBITED_FILTER_KWARGS.intersection(kwargs):
+            if not clone._native_defer_simple_filter(
+                negate, args, kwargs
+            ) and not clone._native_apply_filter(negate, args, kwargs):
+                clone._native_materialize_python_query()
+                clone._filter_or_exclude_inplace(negate, args, kwargs)
+                clone._native_disabled = True
+                clone._native_qs = None
+        return clone
+
+    def _filter_or_exclude_inplace(self, negate, args, kwargs):
+        if invalid_kwargs := PROHIBITED_FILTER_KWARGS.intersection(kwargs):
             invalid_kwargs_str = ", ".join(f"'{k}'" for k in sorted(invalid_kwargs))
             raise TypeError(f"The following kwargs are invalid: {invalid_kwargs_str}")
+        query = self._query
+        if query is None:
+            query = self._query = sql.Query(self.model)
         if negate:
-            self._query.add_q(~Q(*args, **kwargs))
+            query.add_q(~Q(*args, **kwargs))
         else:
-            self._query.add_q(Q(*args, **kwargs))
+            query.add_q(Q(*args, **kwargs))
 
     def _native_eligible_for_dataplane(self):
         """Query shapes the C++ data plane can still own."""
-        query = self.query
+        query = self._query
+        if query is None:
+            return True
         # Annotations/select_related may be owned by the native handle itself.
         if (
             query.combinator
@@ -2615,52 +2741,213 @@ class QuerySet(AltersData):
             return False
         return True
 
-    def _native_track_filter(self, negate, args, kwargs):
-        """
-        Mirror filter/exclude onto a C++ QuerySet handle when possible.
+    def _native_store_plan(self, plan):
+        if plan is None:
+            return False
+        self._native_plan = plan
+        self._native_authoritative = True
+        return True
 
-        On miss, poison the handle so we never mix partial native state.
-        """
-        if getattr(self, "_native_disabled", False):
+    def _native_plan_candidate(self, operation, payload):
+        """Validate one operation against the registered C++ model schema."""
+        from django.native import orm as native_orm
+
+        orm = native_orm._orm()
+        if orm is None:
+            return None
+        plan = self._native_plan
+        if plan is not None:
+            if operation == "q":
+                return plan.with_q(payload)
+            if operation == "ordering":
+                return plan.with_ordering(payload)
+            if operation == "values":
+                return plan.with_values(payload)
+            return None
+        mid = native_orm.register_model_from_meta(self.model)
+        if mid is None:
+            return None
+        if operation == "q":
+            return orm.QueryPlan.for_q(int(mid), payload)
+        if operation == "ordering":
+            return orm.QueryPlan.for_ordering(int(mid), payload)
+        if operation == "values":
+            return orm.QueryPlan.for_values(int(mid), payload)
+        return None
+
+    def _native_plan_with_q(self, tree):
+        return self._native_store_plan(self._native_plan_candidate("q", tree))
+
+    def _native_plan_with_ordering(self, field_names):
+        return self._native_store_plan(
+            self._native_plan_candidate("ordering", field_names)
+        )
+
+    def _native_plan_with_values(self, fields):
+        return self._native_store_plan(
+            self._native_plan_candidate("values", fields)
+        )
+
+    def _native_materialize_python_query(self):
+        """Replay the compact native plan into a Python Query on demand."""
+        if not self._native_authoritative:
             return
+        query = (
+            self._query.chain()
+            if self._query is not None
+            else sql.Query(self.model)
+        )
+        replay = self._native_plan.replay() if self._native_plan is not None else ()
+        for operation in replay:
+            kind = operation[0]
+            if kind == "filter":
+                query.add_q(_q_from_native_tree(operation[1]))
+            elif kind == "order_by":
+                query.clear_ordering(force=True, clear_default=False)
+                query.add_ordering(*operation[1])
+            elif kind == "values":
+                query.set_values(operation[1])
+        self._query = query
+        self._native_authoritative = False
+        self._native_plan = None
+        self._native_disabled = True
+        self._native_qs = None
+
+    def _native_has_only_projection(self):
+        return (
+            self._native_authoritative
+            and self._native_plan is not None
+            and self._native_plan.has_only_projection()
+        )
+
+    def _native_plan_has_simple_filter(self):
+        return (
+            self._native_authoritative
+            and self._native_plan is not None
+            and self._native_plan.has_simple_filter()
+        )
+
+    def _native_ordering_is_safe(self, field_names):
+        if self.model._meta.parents:
+            return False
+        for item in field_names:
+            if not isinstance(item, str) or item == "?":
+                return False
+            name = item.removeprefix("-")
+            if not name or LOOKUP_SEP in name:
+                return False
+        return True
+
+    def _native_defer_simple_filter(self, negate, args, kwargs):
+        """Keep one safe primitive exact/IN filter for a fused terminal call."""
+        if (
+            negate
+            or args
+            or len(kwargs) != 1
+            or self._native_authoritative
+            or self._native_qs is not None
+            or self._native_disabled
+            or self.model._meta.parents
+            or self.model._meta.ordering
+            or not self._simple_base_eligible()
+        ):
+            return False
+        try:
+            from django.native import orm as native_orm
+
+            orm = native_orm._orm()
+            if orm is None:
+                return False
+            key, value = next(iter(kwargs.items()))
+            if not isinstance(key, str):
+                return False
+            parts = key.split(LOOKUP_SEP)
+            lookup_in = len(parts) == 2 and parts[1] == "in"
+            if len(parts) != (2 if lookup_in else 1):
+                return False
+            if lookup_in:
+                if not isinstance(value, (list, tuple)) or not value:
+                    return False
+                values = tuple(value)
+            else:
+                values = (value,)
+            mid = native_orm.register_model_from_meta(self.model)
+            if mid is None:
+                return False
+            plan = orm.QueryPlan.for_simple_filter(
+                int(mid), parts[0], lookup_in, values
+            )
+            return self._native_store_plan(plan)
+        except Exception:
+            return False
+
+    def _native_apply_filter(self, negate, args, kwargs):
+        """Apply a filter to the authoritative C++ graph without Python Query."""
         if not args and not kwargs:
-            return
+            return True
+        if getattr(self, "_native_disabled", False):
+            return False
         try:
             from django.native import orm as native_orm
 
-            if native_orm._orm() is None:
-                self._native_disabled = True
-                return
-            if not self._native_eligible_for_dataplane():
-                self._native_disabled = True
-                self._native_qs = None
-                return
+            orm = native_orm._orm()
+            if orm is None or not self._native_eligible_for_dataplane():
+                return False
+            if not self._native_authoritative and not self._simple_base_eligible():
+                return False
             q_obj = Q(*args, **kwargs)
             if negate:
                 q_obj = ~q_obj
+            if self.model._meta.ordering:
+                return False
+            tree = native_orm.q_to_tree(q_obj)
+            if tree is None:
+                return False
+            plan = self._native_plan_candidate("q", tree)
+            if plan is None:
+                return False
             handle = getattr(self, "_native_qs", None)
+            # A deferred simple filter has no C++ handle yet. Starting a new
+            # handle from only this Q object would silently omit that first
+            # predicate, so let the caller replay both filters into Python.
+            if handle is None and self._native_plan_has_simple_filter():
+                return False
             if handle is None:
-                handle = native_orm.build_queryset(
-                    self.model, connections[self.db], q=q_obj
+                mid = native_orm.register_model_from_meta(self.model)
+                dialect = native_orm.dialect_for_connection(connections[self.db])
+                if mid is None or dialect is None:
+                    return False
+                handle = orm.QuerySet.create_from_native_q(
+                    int(mid), int(dialect), tree
                 )
                 if handle is None:
-                    self._native_disabled = True
-                    self._native_qs = None
-                    return
+                    return False
+                # values()/values_list() may precede filter().
+                if self._fields is not None:
+                    if self._iterable_class is ValuesIterable:
+                        if not handle.values(list(self._fields)):
+                            return False
+                    elif self._iterable_class in (
+                        ValuesListIterable,
+                        FlatValuesListIterable,
+                    ):
+                        if not handle.values_list(
+                            list(self._fields),
+                            self._iterable_class is FlatValuesListIterable,
+                        ):
+                            return False
                 self._native_qs = handle
             else:
-                cloned = handle.clone()
-                if not native_orm.apply_q(cloned, q_obj):
-                    self._native_disabled = True
-                    self._native_qs = None
-                    return
-                self._native_qs = cloned
+                handle = handle.with_native_q(tree)
+                if handle is None:
+                    return False
+                self._native_qs = handle
+            return self._native_store_plan(plan)
         except Exception:
-            self._native_disabled = True
-            self._native_qs = None
+            return False
 
     def _native_handle_for_sql(self):
-        if getattr(self, "_native_disabled", False):
+        if getattr(self, "_native_disabled", False) or not self._native_authoritative:
             return None
         handle = getattr(self, "_native_qs", None)
         if handle is None:
@@ -2801,16 +3088,10 @@ class QuerySet(AltersData):
         obj = self._chain()
         if fields == (None,):
             obj.query.select_related = False
-            if getattr(obj, "_native_qs", None) is not None:
-                # Cannot clear joins easily; poison native for this branch.
-                obj._native_disabled = True
-                obj._native_qs = None
         elif fields:
             obj.query.add_select_related(fields)
-            obj._native_track_select_related(fields)
         else:
             obj.query.select_related = True
-            obj._native_track_select_related_all()
         return obj
 
     def _native_ensure_handle(self):
@@ -2826,9 +3107,7 @@ class QuerySet(AltersData):
             if handle is None:
                 if not self._native_eligible_for_dataplane():
                     return None
-                handle = native_orm.build_queryset(
-                    self.model, connections[self.db]
-                )
+                handle = native_orm.build_queryset(self.model, connections[self.db])
                 if handle is None:
                     return None
                 self._native_qs = handle
@@ -2922,9 +3201,10 @@ class QuerySet(AltersData):
                 elif isinstance(expr, Subquery):
                     # Prefer fully native nested QuerySet when possible.
                     sub_qs = getattr(expr, "queryset", None)
-                    if sub_qs is not None and getattr(
-                        sub_qs, "_native_qs", None
-                    ) is not None:
+                    if (
+                        sub_qs is not None
+                        and getattr(sub_qs, "_native_qs", None) is not None
+                    ):
                         if not h.annotate_subquery_qs(alias, sub_qs._native_qs):
                             self._native_disabled = True
                             self._native_qs = None
@@ -3012,9 +3292,7 @@ class QuerySet(AltersData):
                     lhs, rhs = expr.lhs, expr.rhs
                     connector = expr.connector  # '+', '-', etc.
                     if isinstance(lhs, F) and isinstance(rhs, Value):
-                        ok = h.annotate_binop(
-                            alias, lhs.name, connector, rhs.value
-                        )
+                        ok = h.annotate_binop(alias, lhs.name, connector, rhs.value)
                     elif isinstance(lhs, F) and isinstance(rhs, F):
                         ok = h.annotate_binop_fields(
                             alias, lhs.name, connector, rhs.name
@@ -3045,55 +3323,22 @@ class QuerySet(AltersData):
         When prefetch_related() is called more than once, append to the list of
         prefetch lookups. If prefetch_related(None) is called, clear the list.
         """
-        from django import native as _native
-
         self._not_support_combined_queries("prefetch_related")
         clone = self._chain()
-        clear = (
-            _native.clear_none_arg(lookups == (None,))
-            if _native.AVAILABLE
-            else lookups == (None,)
-        )
-        if clear:
+        if lookups == (None,):
             clone._prefetch_related_lookups = ()
-            if getattr(clone, "_native_qs", None) is not None:
-                # Prefetch list cleared; leave handle otherwise intact.
-                pass
         else:
             for lookup in lookups:
                 if isinstance(lookup, Prefetch):
                     lookup = lookup.prefetch_to
-                if _native.AVAILABLE:
-                    lookup = _native.lookup_head(str(lookup))
-                else:
-                    lookup = lookup.split(LOOKUP_SEP, 1)[0]
+                lookup = lookup.split(LOOKUP_SEP, 1)[0]
                 if lookup in self.query._filtered_relations:
                     raise ValueError(
                         "prefetch_related() is not supported with FilteredRelation."
                     )
             clone._prefetch_related_lookups = clone._prefetch_related_lookups + lookups
-            clone._native_track_prefetch(lookups)
         return clone
 
-    def _native_track_prefetch(self, lookups):
-        if getattr(self, "_native_disabled", False):
-            return
-        try:
-            h = self._native_ensure_handle()
-            if h is None:
-                return
-            for lookup in lookups:
-                if isinstance(lookup, Prefetch):
-                    path = lookup.prefetch_to
-                else:
-                    path = str(lookup)
-                # Full multi-hop path: C++ emits one PrefetchSpec per hop.
-                if not h.add_prefetch(path):
-                    # Leave Django prefetch list intact for fallback
-                    continue
-        except Exception:
-            pass
-
     def annotate(self, *args, **kwargs):
         """
         Return a query set in which the returned objects have been annotated
@@ -3132,7 +3377,6 @@ class QuerySet(AltersData):
         annotations.update(kwargs)
 
         clone = self._chain()
-        clone._native_track_annotate(annotations, select=select)
         names = self._fields
         if names is None:
             names = set(
@@ -3180,12 +3424,50 @@ class QuerySet(AltersData):
         """Return a new QuerySet instance with the ordering changed."""
         from django import native as _native
 
-        if _native.AVAILABLE:
-            if _native.queryset_sliced_error(self.query.is_sliced):
-                raise TypeError("Cannot reorder a query once a slice has been taken.")
-        elif self.query.is_sliced:
+        if self._query is not None and self._query.is_sliced:
             raise TypeError("Cannot reorder a query once a slice has been taken.")
         obj = self._chain()
+        if _native.AVAILABLE and obj._native_ordering_is_safe(field_names):
+            if (
+                obj._native_qs is None
+                and obj._native_authoritative
+                and obj._native_plan_has_simple_filter()
+            ):
+                if obj._native_plan_with_ordering(field_names):
+                    return obj
+            try:
+                from django.native import orm as native_orm
+
+                handle = obj._native_qs
+                if handle is not None and not obj._native_authoritative:
+                    handle = None
+                if handle is None and obj._simple_base_eligible():
+                    handle = native_orm.build_queryset(obj.model, connections[obj.db])
+                    if handle is not None and obj._fields is not None:
+                        if obj._iterable_class is ValuesIterable:
+                            projected = handle.values(list(obj._fields))
+                        else:
+                            projected = handle.values_list(
+                                list(obj._fields),
+                                obj._iterable_class is FlatValuesListIterable,
+                            )
+                        if not projected:
+                            handle = None
+                ordered = (
+                    handle.with_ordering(list(field_names))
+                    if handle is not None
+                    else None
+                )
+                if ordered is not None:
+                    obj._native_qs = ordered
+                    if obj._native_plan_with_ordering(field_names):
+                        return obj
+            except Exception:
+                pass
+
+        obj._native_materialize_python_query()
+        obj._native_disabled = True
+        obj._native_qs = None
         obj.query.clear_ordering(force=True, clear_default=False)
         obj.query.add_ordering(*field_names)
         return obj
@@ -3265,9 +3547,7 @@ class QuerySet(AltersData):
                 False, False, False, self._fields is not None
             )
             if code == 4:
-                raise TypeError(
-                    "Cannot call defer() after .values() or .values_list()"
-                )
+                raise TypeError("Cannot call defer() after .values() or .values_list()")
         elif self._fields is not None:
             raise TypeError("Cannot call defer() after .values() or .values_list()")
         clone = self._chain()
@@ -3296,16 +3576,12 @@ class QuerySet(AltersData):
                 False, False, False, self._fields is not None
             )
             if code == 4:
-                raise TypeError(
-                    "Cannot call only() after .values() or .values_list()"
-                )
+                raise TypeError("Cannot call only() after .values() or .values_list()")
             if _native.only_none_arg_error(fields == (None,)):
                 raise TypeError("Cannot pass None as an argument to only().")
         else:
             if self._fields is not None:
-                raise TypeError(
-                    "Cannot call only() after .values() or .values_list()"
-                )
+                raise TypeError("Cannot call only() after .values() or .values_list()")
             if fields == (None,):
                 # Can only pass None to defer(), not only(), as the rest option.
                 # That won't stop people trying to do this, so let's be explicit.
@@ -3476,14 +3752,8 @@ class QuerySet(AltersData):
         Return a copy of the current QuerySet that's ready for another
         operation.
         """
-        from django import native as _native
-
         obj = self._clone()
-        if _native.AVAILABLE:
-            if _native.sticky_filter_active(obj._sticky_filter):
-                obj.query.filter_is_sticky = True
-                obj._sticky_filter = False
-        elif obj._sticky_filter:
+        if obj._sticky_filter:
             obj.query.filter_is_sticky = True
             obj._sticky_filter = False
         return obj
@@ -3493,11 +3763,20 @@ class QuerySet(AltersData):
         Return a copy of the current QuerySet. A lightweight alternative
         to deepcopy().
         """
+        native_authoritative = getattr(self, "_native_authoritative", False)
+        if self._deferred_filter:
+            # Related managers deliberately defer their core filter until the
+            # Query is cloned. Preserve Django's property-access semantics.
+            query = self.query.chain()
+            native_authoritative = False
+        else:
+            query = (
+                self._query
+                if native_authoritative or self._query is None
+                else self.query.chain()
+            )
         c = self.__class__(
-            model=self.model,
-            query=self.query.chain(),
-            using=self._db,
-            hints=self._hints,
+            model=self.model, query=query, using=self._db, hints=self._hints
         )
         c._sticky_filter = self._sticky_filter
         c._for_write = self._for_write
@@ -3505,19 +3784,17 @@ class QuerySet(AltersData):
         c._known_related_objects = self._known_related_objects
         c._iterable_class = self._iterable_class
         c._fields = self._fields
-        # Native data-plane handle (cloned; mutations must not alias parent).
+        # Native mutations are functional COW operations, so cloning the
+        # Python QuerySet can share this wrapper without a native crossing.
         parent_native = getattr(self, "_native_qs", None)
         if parent_native is not None:
-            try:
-                c._native_qs = parent_native.clone()
-            except Exception:
-                c._native_qs = None
-                c._native_disabled = True
-            else:
-                c._native_disabled = getattr(self, "_native_disabled", False)
+            c._native_qs = parent_native
+            c._native_disabled = getattr(self, "_native_disabled", False)
         else:
             c._native_qs = None
             c._native_disabled = getattr(self, "_native_disabled", False)
+        c._native_authoritative = native_authoritative
+        c._native_plan = getattr(self, "_native_plan", None)
         return c
 
     def _fetch_all(self):
@@ -3606,10 +3883,11 @@ class QuerySet(AltersData):
             )
 
     def _not_support_combined_queries(self, operation_name):
-        if self.query.combinator:
+        combinator = self._query.combinator if self._query is not None else None
+        if combinator:
             raise NotSupportedError(
                 "Calling QuerySet.%s() after %s() is not supported."
-                % (operation_name, self.query.combinator)
+                % (operation_name, combinator)
             )
 
     def _check_operator_queryset(self, other, operator_):
